<template>
    <div class="chartBox">
        <div class="ChartBox">
            <JwChat-index :taleList="list" @enter="bindEnter" v-model="inputMsg" :toolConfig="tool">

            </JwChat-index>
        </div>
    </div>
    <!--  -->
</template>
  
<script>
import msgData from '../../assets/js/msg/msgData';
import store from '../../store';

export default {
    name: 'jwChat',

    data() {
        return {
            inputMsg: '',
            loading: false,
            list: [],
            msgData: [],
            tool: {
                show: ['file', 'history', 'img'],
                callback: this.toolEvent
            },
            config: {
                img: '/image/cover.png',
                name: 'JwChat',
                dept: '最简单、最便捷',
                callback: this.bindCover
            },
        }
    },
    computed: {
        Obj() {
            return store.state.setMsgData
        }

    },
    watch: {
        Obj(newVal, oldVal) {
            if (newVal) {
                if (newVal.text == '加载完成') {
                    setTimeout(() => {
                        this.setMsgImg();
                    }, 500);
                    setTimeout(() => {
                        this.setMsgtab();
                    }, 1500);
                    this.loading = false;
                    store.state.setMsgData = null;

                } else {
                    this.list[this.list.length - 1].text = newVal
                }

            }
        }
    },
    mounted() {
        if (window.timer) {
            clearInterval(window.timer);
            window.timer = null;
        }
        setTimeout(() => {
            this.setMsgStart();
        }, config.loadTime);
    },
    methods: {
        bindEnter() {
            const msg = this.inputMsg
            if (!msg) return;
            this.getMsg("role", msg)
            setTimeout(() => {
                this.loading = true;
                const loader = msgData.getLoader()
                this.list.push(loader)
            }, 200);

        },
        setMsgStart() {
            var msg = aiData.aiMsg[0]
            this.getMsg("ai", msg)
        },
        getMsg(type, msg) {
            var roleMsg = msgData.getRole(type, msg);
            this.list.push(roleMsg.msg)
            if (roleMsg.aiMsg) {
                this.msgData = roleMsg.aiMsg;
                setTimeout(() => {
                    this.setShowMsg();
                }, 2000);

            }
        },
        setShowMsg() {
            if (this.msgData.text) {
                this.setMsgText()
            } else if (this.msgData.img) {
                this.setMsgImg();
            }
        },
        setMsgText() {
            if (this.msgData.text) {
                msgData.setmsgText(this.msgData.text)
            }

        },
        setMsgImg() {

            if (this.msgData.img) {

                var val = msgData.setmsgImg(this.msgData.img)

                this.list.push(val)

            }
        },
        setMsgtab() {
            if (this.msgData.tab) {

                var val = msgData.setmsgtab(this.msgData.tab)

                this.list.push(val)

            }
        },
        getLoadingFlag() {
            if (this.list.length == 0) {
                return;
            }
            var load = this.list[this.list.length - 1].text;
            if (load.indexOf = "loading" > -1) {
                return true;
            }
            return false;

        },

    }
}
</script>
<style scoped>
/* .rightSlot {
    width: 100%;
    height: 100%;
    overflow: hidden;
    flex-direction: column;
} */
.chartBox {
    width: 100%;
    height: 100vh;
    background: black;
    position: relataive;

}
</style>
<style>
.divboder {
    display: flex;

}

.tabTable {
    width: 100%;
    min-width: 25vh !important;
    text-align: center;
    border: 1px solid #C1C1C1;
}

.tabTable .tabHeader {
    height: 32px;
    background: linear-gradient(180deg, #28A9DE 0%, #1987C2 100%);
    border-radius: 0px 0px 0px 0px;
    color: white;
}

.tabTable .tabBody tr {
    height: 64px;
    border-bottom: 1px solid #C1C1C1;
}

.tabTable .tabBody td:nth-child(2){
    height: 64px;
    word-break: break-all;
    word-wrap: break-word;
    text-align: center;
    width: 68%;
    padding: 0px 1%;
    line-height: 30px;
    border-bottom: 1px solid #C1C1C1;
}
@keyframes siz {

    from {
        width: 0;
    }

    to {
        width: 100%;
    }

}

.msgText {
    width: 300px;
    word-break: break-all;
    word-wrap: break-word;
    overflow: hidden;
    white-space: normal;
    letter-spacing: 0.15em;
    animation: siz 3s steps(60) forwards
}

.loading {
    margin: 20px;
    position: relative;
    width: 1px;
    height: 1px;
}

.loading:before,
.loading:after {
    position: absolute;
    display: inline-block;
    width: 15px;
    height: 15px;
    content: "";
    border-radius: 100%;
    background-color: #000;
}

.loading:before {
    left: -15px;
    animation: ball-pulse infinite 0.75s -0.4s cubic-bezier(0.2, 0.68, 0.18, 1.08);
}

.loading:after {
    right: -15px;
    animation: ball-pulse infinite 0.75s cubic-bezier(0.2, 0.68, 0.18, 1.08);
}

@keyframes ball-pulse {
    0% {
        transform: scale(1);
        opacity: 1;
    }

    50% {
        transform: scale(0.1);
        opacity: 0.6;
    }

    100% {
        transform: scale(1);
        opacity: 1;
    }
}
</style>

  